#include "StdAfx.h"
#include ".\rss200feedparserPug.h"
#include "GNUtil.h"

CRss200FeedParserPug::CRss200FeedParserPug(std::vector<wchar_t>* pContent, pug::xml_parser* pxmlparser)
	: CRss09xFeedParserPug(pContent, pxmlparser)
{
	m_newsFeed.m_format = GetFormatName(RSS200);
}

CRss200FeedParserPug::~CRss200FeedParserPug(void)
{
}


//<?xml version="1.0"?>
//<rss version="2.0">
//   <channel>
//      <title>Liftoff News</title>
//      <link>http://liftoff.msfc.nasa.gov/</link>
//      <description>Liftoff to Space Exploration.</description>
//      <language>en-us</language>
//      <pubDate>Tue, 10 Jun 2003 04:00:00 GMT</pubDate>
//      <lastBuildDate>Tue, 10 Jun 2003 09:41:01 GMT</lastBuildDate>
//      <docs>http://blogs.law.harvard.edu/tech/rss</docs>
//      <generator>Weblog Editor 2.0</generator>
//      <managingEditor>editor@example.com</managingEditor>
//      <webMaster>webmaster@example.com</webMaster>
//      <item>
//         <title>Star City</title>
//         <link>http://liftoff.msfc.nasa.gov/news/2003/news-starcity.asp</link>
//         <description>How do Americans get ready to work with Russians aboard the International Space Station? They take a crash course in culture, language and protocol at Russia's &lt;a href="http://howe.iki.rssi.ru/GCTC/gctc_e.htm"&gt;Star City&lt;/a&gt;.</description>
//         <pubDate>Tue, 03 Jun 2003 09:39:21 GMT</pubDate>
//         <guid>http://liftoff.msfc.nasa.gov/2003/06/03.html#item573</guid>
//      </item>
//      <item>
//         <description>Sky watchers in Europe, Asia, and parts of Alaska and Canada will experience a &lt;a href="http://science.nasa.gov/headlines/y2003/30may_solareclipse.htm"&gt;partial eclipse of the Sun&lt;/a&gt; on Saturday, May 31st.</description>
//         <pubDate>Fri, 30 May 2003 11:06:42 GMT</pubDate>
//         <guid>http://liftoff.msfc.nasa.gov/2003/05/30.html#item572</guid>
//      </item>
//      <item>
//         <title>The Engine That Does More</title>
//         <link>http://liftoff.msfc.nasa.gov/news/2003/news-VASIMR.asp</link>
//         <description>Before man travels to Mars, NASA hopes to design new engines that will let us fly through the Solar System more quickly.  The proposed VASIMR engine would do that.</description>
//         <pubDate>Tue, 27 May 2003 08:37:32 GMT</pubDate>
//         <guid>http://liftoff.msfc.nasa.gov/2003/05/27.html#item571</guid>
//      </item>
//      <item>
//         <title>Astronauts' Dirty Laundry</title>
//         <link>http://liftoff.msfc.nasa.gov/news/2003/news-laundry.asp</link>
//         <description>Compared to earlier spacecraft, the International Space Station has many luxuries, but laundry facilities are not one of them.  Instead, astronauts have other options.</description>
//         <pubDate>Tue, 20 May 2003 08:56:02 GMT</pubDate>
//         <guid>http://liftoff.msfc.nasa.gov/2003/05/20.html#item570</guid>
//      </item>
//   </channel>
//</rss>
void CRss200FeedParserPug::Parse()
{
	CRss09xFeedParserPug::Parse();
}

bool CRss200FeedParserPug::PopulateNewsItem(NewsItemPtr& pNews, pug::xml_node& item)
{
	CRss09xFeedParserPug::PopulateNewsItem(pNews, item);

	ParseNode(pNews->m_author, item, _T("./author"));
	ParseNode(pNews->m_commentsURL, item, _T("./comments"));

	// get pod casting enclosure URL
	pug::xml_node pod_casting = item.first_element_by_attribute(_T("enclosure"), _T("type"), _T("audio/mpeg"));
	if(!pod_casting.empty() && pod_casting.has_attribute(_T("url")))
	{
		if(CGNUtil::IsValidPoscastingUrl(pod_casting.attribute(_T("url")).value()))
			pNews->m_podCastingURL = pod_casting.attribute(_T("url")).value();
	}

	return true;
}
