#include "stdafx.h"
#include "resource.h"
#include "ExportDlg.h"
#include "FeedManagerLib.h"
#include "GNFileDialog.h"

#import "msxml3.dll"

LRESULT CExportDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	ATLTRACE("CExportDlg::OnInitDialog()\n");
	DoDataExchange(false);

	CenterWindow(GetParent());

	return 0;
} // OnInitDialog

LRESULT CExportDlg::OnIdcancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	EndDialog(wID);
	return 0;
} // OnIdcancel

LRESULT CExportDlg::OnBtnbrowse(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CGNFileDialog dlg(true, _T("xml"), _T(""), OFN_HIDEREADONLY, 
		_T("OPML Files (opml, xml)\0*.opml;*.xml\0All Files (*.*)\0*.*\0"),
		NULL, false);

	if(dlg.DoModal() == IDOK)
	{
		SetDlgItemText(IDC_TXTFILENAME, dlg.m_szFileName);
	}

	return 0;
} // OnBtnbrowse

LRESULT CExportDlg::OnIdok(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	DoDataExchange(true);

	bool bSucceeded = false;

	//try
	//{
	//	CString opml = "<opml version=\"1.1\">\n";
	//	opml += "\t<head/>\n";
	//	opml += "\t<body>\n";

	//	FeedGroupPtr spRootFeedGroup = CFeedGroup::GetRootFeedGroup();
	//	FeedGroupVector childGroups = spRootFeedGroup->GetChildGroups();
	//	for(FeedGroupVector::iterator it = childGroups.begin(); it != childGroups.end(); it++)
	//	{
	//		FeedGroupPtr spGroup = *it;
	//		opml.AppendFormat("\t\t<outline text=\"%s\" title=\"%s\">\n",
	//			(LPCTSTR)spGroup->m_name,
	//			(LPCTSTR)spGroup->m_name);

	//		NewsFeedVector newsfeeds = spGroup->GetNewsFeeds();
	//		for(NewsFeedVector::iterator nit = newsfeeds.begin(); nit!=newsfeeds.end(); nit++)
	//		{
	//			NewsFeedPtr spNewsFeed = *nit;
	//			opml.AppendFormat("\t\t\t<outline text=\"%s\" title=\"%s\" xmlUrl=\"%s\" htmlUrl=\"%s\" />\n",
	//				(LPCTSTR)spNewsFeed->m_title,
	//				(LPCTSTR)spNewsFeed->m_title,
	//				(LPCTSTR)spNewsFeed->m_url,
	//				(LPCTSTR)spNewsFeed->m_website);
	//		}

	//		opml += "\t\t</outline>\n";
	//	}
	//	opml += "\t</body>\n";
	//	opml += "</opml>\n";

	//	CAtlFile opmlFile;
	//	if (opmlFile.Create(m_fileName, FILE_WRITE_DATA, FILE_SHARE_WRITE,
	//			OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL) != S_OK)
	//	{
	//		CString msg;
	//		msg.Format("Cannot create output file[%s]", m_fileName);
	//		MessageBox(msg);
	//		return 0;
	//	}
	//	opmlFile.Write((LPCSTR)opml, opml.GetLength());
	//	opmlFile.Close();

	//	MessageBox("Channels and Groups were successfully exported.");

	//	bSucceeded = true;
	//}
	//CATCH_ALL_ERROR()


	try
	{
		FeedGroupPtr spRootFeedGroup = CFeedGroup::GetRootFeedGroup();

		MSXML2::IXMLDOMDocumentPtr spDoc(_T("MSXML2.DOMDocument.3.0")); 
		MSXML2::IXMLDOMElementPtr opml = spDoc->createElement("opml");
		spDoc->appendChild(opml);
		opml->setAttribute("version","1.1");
		
		MSXML2::IXMLDOMElementPtr head = spDoc->createElement("head");
		opml->appendChild(head);
		MSXML2::IXMLDOMElementPtr body = spDoc->createElement("body");
		opml->appendChild(body);

		int nGroup=1; // 1 is the root group
		int nFeed =0;

		FeedGroupVector childGroups = spRootFeedGroup->GetChildGroups();
		for(FeedGroupVector::iterator it = childGroups.begin(); it != childGroups.end(); it++)
		{
			nGroup++;
			FeedGroupPtr spGroup = *it;
			MSXML2::IXMLDOMElementPtr group = spDoc->createElement("outline");
			group->setAttribute("text", (LPCTSTR)spGroup->m_name);
			group->setAttribute("title", (LPCTSTR)spGroup->m_name);
			body->appendChild(group);

			NewsFeedVector newsfeeds = spGroup->GetNewsFeeds(true);
			for(NewsFeedVector::iterator nit = newsfeeds.begin(); nit!=newsfeeds.end(); nit++)
			{
				nFeed++;
				NewsFeedPtr spNewsFeed = *nit;
				MSXML2::IXMLDOMElementPtr feed = spDoc->createElement("outline");
				feed->setAttribute("text", (LPCTSTR)spNewsFeed->m_title);
				feed->setAttribute("title", (LPCTSTR)spNewsFeed->m_title);
				feed->setAttribute("xmlUrl", (LPCTSTR)spNewsFeed->m_url);
				feed->setAttribute("htmlUrl", (LPCTSTR)spNewsFeed->m_website);
			
				group->appendChild(feed);
			}
		}

		NewsFeedVector newsfeeds = spRootFeedGroup->GetNewsFeeds(true);
		for(NewsFeedVector::iterator nit = newsfeeds.begin(); nit!=newsfeeds.end(); nit++)
		{
			nFeed++;
			NewsFeedPtr spNewsFeed = *nit;
			MSXML2::IXMLDOMElementPtr feed = spDoc->createElement("outline");
			feed->setAttribute("text", (LPCTSTR)spNewsFeed->m_title);
			feed->setAttribute("title", (LPCTSTR)spNewsFeed->m_title);
			feed->setAttribute("xmlUrl", (LPCTSTR)spNewsFeed->m_url);
			feed->setAttribute("htmlUrl", (LPCTSTR)spNewsFeed->m_website);
		
			body->appendChild(feed);
		}

		spDoc->save((LPCTSTR)m_fileName);

		CString msg;
		msg.Format(_T("%d Channels and %d Groups were successfully exported."), nFeed, nGroup);
		MessageBox(msg);
		bSucceeded = true;
	}
	CATCH_ALL_ERROR()

	if(bSucceeded)
		EndDialog(wID);

	return 0;
} // OnIdok

/////////////////////////////////////////////////////////////////////////////////////////
