
#define DDX_COMBO_INDEX(nID, var) \
	if(nCtlID == (UINT)-1 || nCtlID == nID) \
	{ \
		if(!DDX_Combo_Index(nID, var, TRUE, bSaveAndValidate)) \
		return FALSE; \
	}

template <class Type>
class CMyWinDataExchange : public CWinDataExchange<Type>
{
	BOOL DDX_Combo_Index(UINT nID, 
						Type& nVal, 
						BOOL bSigned, 
						BOOL bSave, 
						BOOL bValidate = FALSE, 
						Type nMin = 0, 
						Type nMax = 0)
	{
		Type* pT = static_cast<Type*>(this);
		BOOL bSuccess = TRUE;

		if(bSave)
		{
			nVal = ::SendMessage((HWND) pT->GetDlgItem(nID),
				CB_GETCURSEL,
				(WPARAM) 0,
				(LPARAM) 0);
			bSuccess = (nVal == CB_ERR ? false : true);	
		}
		else
		{
			ATLASSERT(!bValidate || nVal >= nMin && nVal <= nMax);
			int iRet = 	::SendMessage((HWND)pT->GetDlgItem(nID),
				CB_SETCURSEL,
				(WPARAM) nVal,
				(LPARAM) 0);

			bSuccess = (iRet == CB_ERR ? false : true);
		}

		if(!bSuccess)
		{
			pT->OnDataExchangeError(nID, bSave);
		}
		else if(bSave && bValidate)	// validation
		{
			ATLASSERT(nMin != nMax);
			if(nVal < nMin || nVal > nMax)
			{
				_XData data;
				data.nDataType = ddxDataInt;
				data.intData.nVal = (long)nVal;
				data.intData.nMin = (long)nMin;
				data.intData.nMax = (long)nMax;
				pT->OnDataValidateError(nID, bSave, data);
				bSuccess = FALSE;
			}
		}
		return bSuccess;
	}
};