// MainDlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <atlddx.h>
#include <atlctrlx.h>

#include "DownloadStatusCallBack.h"

class CMainDlg : public CDialogImpl<CMainDlg>, public CUpdateUI<CMainDlg>,
		public CMessageFilter, public CIdleHandler,
		public CWinDataExchange<CMainDlg>
{
public:
	enum { IDD = IDD_MAINDLG };

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnIdle();

	BEGIN_UPDATE_UI_MAP(CMainDlg)
	END_UPDATE_UI_MAP()

    BEGIN_DDX_MAP(CFindChannelDlg)
		DDX_RADIO(IDC_RDOINSTALLER, m_nPackaging)
    END_DDX_MAP()

	BEGIN_MSG_MAP(CMainDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(ID_DOWNLOAD, OnDownload)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_ID_HANDLER(ID_DOWNLOAD_READY, OnDownloadReady)
		COMMAND_ID_HANDLER(ID_DOWNLOAD_FAILED, OnDownloadFailed)
		COMMAND_ID_HANDLER(ID_DOWNLOAD_PROGRESS, OnDownloadProgress)
	END_MSG_MAP()

	LRESULT OnDownloadReady(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnDownloadFailed(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnDownloadProgress(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDownload(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	void CloseDialog(int nVal);

private:
	void ShutdownDownload();

private:
	CDownloadStatusCallBack m_download;
	CProgressBarCtrl m_progress;
	CStatic m_msg;
	CFont m_font;
	bool m_bDownloading;
	int m_nPackaging;

	CHyperLink m_linkWhatsNew;
	CHyperLink m_linkHowToUpgrade;

};
